(function() {
    "use strict";

    angular.module("weChatApp")
        .directive("customTable", Table)
    ;

    function Table() {
        return {
            restrict: "E",
            templateUrl: "views/custom-table.html",
            scope: {
                headers: '<',
                rows: '<',
                langKey: '<'
            },
            controller: ["$scope", function($scope) {
                var langKey = "en";
                if(typeof $scope.langKey === "string" && $scope.langKey !== "") {
                    langKey = $scope.langKey.split("_")[0];
                }

                $scope.reverse = false;
                $scope.comparator = function(o1, o2) {
                    if (o1.type === "number" && o2.type === "number") {
                        return o1.value - o2.value;
                    } else if (o1.type === "string" && o2.type === "string") {
                        return o1.value.localeCompare(o2.value, langKey);
                    } else {
                        return 0;
                    }
                };

                var defaultSortingHeader = _.find($scope.headers, function(header) {
                    return header.defaultSort;
                });
                if(defaultSortingHeader) {
                    // make the default sorting in reverse order
                    $scope.orderKey = defaultSortingHeader.name;
                    $scope.reverse = true;
                } else if($scope.headers[0]) {
                    $scope.orderKey = $scope.headers[0].name;
                }

                $scope.sortColumn = function(header) {
                    $scope.orderKey = header.name;
                    $scope.reverse = !$scope.reverse;
                };
            }]
        };
    }
}());