(function() {
    "use strict";

    angular.module("weChatApp")
        .factory("Utility", [Utility])
    ;

    function Utility() {
        var utility = this;

        /**
         * Helper function to calculate the percentage of two given number
         * @param dividend
         * @param divisor
         * @param decimal The number of decimal point the result should keep
         * @returns {*} A string representing the percentage number
         */
        utility.calculatePercentage = function(dividend, divisor, decimal) {
            if(divisor === 0) {
                return 0;
            }
            return ((dividend/divisor)*100).toFixed(decimal);
        };

        utility.genericQueryErrorHandler = function(deferred) {
            return function(error) {
                deferred.reject(error);
            };
        };

        utility.parseStringToDateValue = function(string, format) {
            var momentDate;
            if(format) {
                momentDate = moment(string, format);
            } else {
                momentDate = moment(string);
            }
            return momentDate.isValid() ? momentDate.valueOf() : null;
        };

        return utility;
    }
})();
